diff -urN sbcl-0.8.16/src/code/filesys.lisp sbcl-0.8.16.patched/src/code/filesys.lisp
--- sbcl-0.8.16/src/code/filesys.lisp	2004-08-18 19:23:18.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/filesys.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -192,8 +192,9 @@
       (values absolute (pieces)))))
 
 (defun parse-unix-namestring (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
            (type index start end))
+  (setf namestr (coerce namestr 'simple-base-string))
   (multiple-value-bind (absolute pieces) (split-at-slashes namestr start end)
     (multiple-value-bind (name type version)
 	(let* ((tail (car (last pieces)))
@@ -296,7 +297,7 @@
 	      (t
 	       (error "invalid pattern piece: ~S" piece))))))
        (apply #'concatenate
-	      'simple-string
+	      'simple-base-string
 	      (strings))))))
 
 (defun unparse-unix-directory-list (directory)
@@ -322,7 +323,7 @@
 	   (pieces "/"))
 	  (t
 	   (error "invalid directory component: ~S" dir)))))
-    (apply #'concatenate 'simple-string (pieces))))
+    (apply #'concatenate 'simple-base-string (pieces))))
 
 (defun unparse-unix-directory (pathname)
   (declare (type pathname pathname))
@@ -350,18 +351,18 @@
       (when type-supplied
 	(unless name
 	  (error "cannot specify the type without a file: ~S" pathname))
-	(when (typep type 'simple-base-string)
+	(when (typep type 'simple-string)
 	  (when (position #\. type)
 	    (error "type component can't have a #\. inside: ~S" pathname)))
 	(strings ".")
 	(strings (unparse-unix-piece type))))
-    (apply #'concatenate 'simple-string (strings))))
+    (apply #'concatenate 'simple-base-string (strings))))
 
 (/show0 "filesys.lisp 406")
 
 (defun unparse-unix-namestring (pathname)
   (declare (type pathname pathname))
-  (concatenate 'simple-string
+  (concatenate 'simple-base-string
 	       (unparse-unix-directory pathname)
 	       (unparse-unix-file pathname)))
 
@@ -445,6 +446,7 @@
 				   (follow-links t))
 			      &body body)
   `(block nil
+     (/show0 "about to call %ENUMERATE-MATCHES")
      (%enumerate-matches (pathname ,pathname)
 			 ,verify-existence
 			 ,follow-links
@@ -455,7 +457,7 @@
 
 ;;; Call FUNCTION on matches.
 (defun %enumerate-matches (pathname verify-existence follow-links function)
-  (/noshow0 "entering %ENUMERATE-MATCHES")
+  (/show0 "entering %ENUMERATE-MATCHES")
   (when (pathname-type pathname)
     (unless (pathname-name pathname)
       (error "cannot supply a type without a name:~%  ~S" pathname)))
@@ -463,16 +465,16 @@
 	     (member (pathname-type pathname) '(nil :unspecific)))
     (error "cannot supply a version without a type:~%  ~S" pathname))
   (let ((directory (pathname-directory pathname)))
-    (/noshow0 "computed DIRECTORY")
+    (/show0 "computed DIRECTORY")
     (if directory
 	(ecase (first directory)
 	  (:absolute
-	   (/noshow0 "absolute directory")
+	   (/show0 "absolute directory")
 	   (%enumerate-directories "/" (rest directory) pathname
 				   verify-existence follow-links
 				   nil function))
 	  (:relative
-	   (/noshow0 "relative directory")
+	   (/show0 "relative directory")
 	   (%enumerate-directories "" (rest directory) pathname
 				   verify-existence follow-links
 				   nil function)))
@@ -576,16 +578,17 @@
 ;;; Call FUNCTION on files.
 (defun %enumerate-files (directory pathname verify-existence function)
   (declare (simple-string directory))
-  (/noshow0 "entering %ENUMERATE-FILES")
+  (/show0 "entering %ENUMERATE-FILES")
   (let ((name (%pathname-name pathname))
 	(type (%pathname-type pathname))
 	(version (%pathname-version pathname)))
-    (/noshow0 "computed NAME, TYPE, and VERSION")
+    (/show0 "computed NAME, TYPE, and VERSION")
     (cond ((member name '(nil :unspecific))
 	   (/noshow0 "UNSPECIFIC, more or less")
-	   (when (or (not verify-existence)
-		     (sb!unix:unix-file-kind directory))
-	     (funcall function directory)))
+	   (let ((directory (coerce directory 'base-string)))
+	     (when (or (not verify-existence)
+		       (sb!unix:unix-file-kind directory))
+	       (funcall function directory))))
 	  ((or (pattern-p name)
 	       (pattern-p type)
 	       (eq name :wild)
@@ -613,20 +616,20 @@
 				       directory
 				       complete-filename))))))
 	  (t
-	   (/noshow0 "default case")
+	   (/show0 "default case")
 	   (let ((file (concatenate 'base-string directory name)))
-	     (/noshow "computed basic FILE")
+	     (/show0 "computed basic FILE")
 	     (unless (or (null type) (eq type :unspecific))
-	       (/noshow0 "tweaking FILE for more-or-less-:UNSPECIFIC case")
+	       (/show0 "tweaking FILE for more-or-less-:UNSPECIFIC case")
 	       (setf file (concatenate 'base-string file "." type)))
 	     (unless (member version '(nil :newest :wild :unspecific))
-	       (/noshow0 "tweaking FILE for more-or-less-:WILD case")
+	       (/show0 "tweaking FILE for more-or-less-:WILD case")
 	       (setf file (concatenate 'base-string file "."
 				       (quick-integer-to-string version))))
-	     (/noshow0 "finished possibly tweaking FILE")
+	     (/show0 "finished possibly tweaking FILE")
 	     (when (or (not verify-existence)
 		       (sb!unix:unix-file-kind file t))
-	       (/noshow0 "calling FUNCTION on FILE")
+	       (/show0 "calling FUNCTION on FILE")
 	       (funcall function file)))))))
 
 (/noshow0 "filesys.lisp 603")
@@ -679,6 +682,7 @@
 ;;; Convert PATHNAME into a string that can be used with UNIX system
 ;;; calls, or return NIL if no match is found. Wild-cards are expanded.
 (defun unix-namestring (pathname-spec &optional (for-input t))
+  (/show0 "in UNIX-NAMESTRING")
   (let* ((namestring (physicalize-pathname (merge-pathnames pathname-spec)))
 	 (matches nil)) ; an accumulator for actual matches
     (when (wild-pathname-p namestring)
@@ -716,12 +720,16 @@
   #!+sb-doc
   "Return a pathname which is the truename of the file if it exists, or NIL
   otherwise. An error of type FILE-ERROR is signaled if pathname is wild."
+  (/show0 "in PROBE-FILE")
   (let* ((defaulted-pathname (merge-pathnames
 			      pathname
 			      (sane-default-pathname-defaults)))
 	 (namestring (unix-namestring defaulted-pathname t)))
+    (/show0 "got NAMESTRING")
     (when (and namestring (sb!unix:unix-file-kind namestring t))
+      (/show0 "got FILE-KIND")
       (let ((trueishname (sb!unix:unix-resolve-links namestring)))
+	(/show0 "resolved links")
 	(when trueishname
 	  (let* ((*ignore-wildcards* t)
 		 (name (sb!unix:unix-simplify-pathname trueishname))) 
@@ -1040,7 +1048,7 @@
 			       :device (pathname-device pathname)
 			       :directory (subseq dir 0 i))))
 		 (unless (probe-file newpath)
-		   (let ((namestring (namestring newpath)))
+		   (let ((namestring (coerce (namestring newpath) 'base-string)))
 		     (when verbose
 		       (format *standard-output*
 			       "~&creating directory: ~A~%"
diff -urN sbcl-0.8.16/src/code/fop.lisp sbcl-0.8.16.patched/src/code/fop.lisp
--- sbcl-0.8.16/src/code/fop.lisp	2004-09-09 14:10:14.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/fop.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -71,11 +71,12 @@
 ;;; of like READ-SEQUENCE specialized for files of (UNSIGNED-BYTE 8),
 ;;; with an automatic conversion from (UNSIGNED-BYTE 8) into CHARACTER
 ;;; for each element read
-(declaim (ftype (function (stream simple-string &optional index) (values)) read-string-as-bytes))
+(declaim (ftype (function (stream simple-string &optional index) (values))
+                read-string-as-bytes read-string-as-words))
 (defun read-string-as-bytes (stream string &optional (length (length string)))
   (dotimes (i length)
     (setf (aref string i)
-	  (code-char (read-byte stream))))
+	  (sb!xc:code-char (read-byte stream))))
   ;; FIXME: The classic CMU CL code to do this was
   ;;   (READ-N-BYTES FILE STRING START END).
   ;; It was changed for SBCL because we needed a portable version for
@@ -83,6 +84,16 @@
   ;; significantly better than the portable version here. If it is, then use
   ;; it as an alternate definition, protected with #-SB-XC-HOST.
   (values))
+(defun read-string-as-words (stream string &optional (length (length string)))
+  #+sb-xc-host (bug "READ-STRING-AS-WORDS called")
+  (dotimes (i length)
+    (setf (aref string i)
+	  (sb!xc:code-char (logior
+                            (read-byte stream)
+                            (ash (read-byte stream) 8)
+                            (ash (read-byte stream) 16)
+                            (ash (read-byte stream) 24)))))
+  (values))
 
 ;;;; miscellaneous fops
 
@@ -123,11 +134,8 @@
   #-sb-xc-host
   (%primitive sb!c:make-other-immediate-type 0 sb!vm:unbound-marker-widetag))
 
-;;; CMU CL had FOP-CHARACTER as fop 68, but it's not needed in current
-;;; SBCL as we have no extended characters, only 1-byte characters.
-;;; (Ditto for CMU CL, actually: FOP-CHARACTER was speculative generality.)
-(define-fop (fop-short-character 69)
-  (code-char (read-byte-arg)))
+(define-cloned-fops (fop-character 68) (fop-short-character 69)
+  (code-char (clone-arg)))
 
 (define-cloned-fops (fop-struct 48) (fop-small-struct 49)
   (let* ((size (clone-arg))
@@ -183,7 +191,12 @@
 			      (make-string (* ,n-size 2))))
 		      (done-with-fast-read-byte)
 		      (let ((,n-buffer *fasl-symbol-buffer*))
-			(read-string-as-bytes *fasl-input-stream*
+                        #+sb-xc-host
+                        (read-string-as-bytes *fasl-input-stream*
+                                              ,n-buffer
+                                              ,n-size)
+                        #-sb-xc-host
+			(read-string-as-words *fasl-input-stream*
 					      ,n-buffer
 					      ,n-size)
 			(push-fop-table (without-package-locks
@@ -232,7 +245,7 @@
 		    (fop-uninterned-small-symbol-save 13)
   (let* ((arg (clone-arg))
 	 (res (make-string arg)))
-    (read-string-as-bytes *fasl-input-stream* res)
+    (read-string-as-words *fasl-input-stream* res)
     (push-fop-table (make-symbol res))))
 
 (define-fop (fop-package 14)
@@ -344,12 +357,23 @@
 
 ;;;; fops for loading arrays
 
-(define-cloned-fops (fop-string 37) (fop-small-string 38)
+(define-cloned-fops (fop-base-string 37) (fop-small-base-string 38)
   (let* ((arg (clone-arg))
-	 (res (make-string arg)))
+	 (res (make-string arg :element-type 'base-char)))
     (read-string-as-bytes *fasl-input-stream* res)
     res))
 
+#+sb-xc-host
+(define-cloned-fops (fop-character-string 161) (fop-small-character-string 162)
+  (bug "CHARACTER-STRING FOP encountered"))
+
+#-sb-xc-host
+(define-cloned-fops (fop-character-string 161) (fop-small-character-string 162)
+  (let* ((arg (clone-arg))
+	 (res (make-string arg)))
+    (read-string-as-words *fasl-input-stream* res)
+    res))
+
 (define-cloned-fops (fop-vector 39) (fop-small-vector 40)
   (let* ((size (clone-arg))
 	 (res (make-array size)))
@@ -639,7 +663,7 @@
   (let* ((kind (pop-stack))
 	 (code-object (pop-stack))
 	 (len (read-byte-arg))
-	 (sym (make-string len)))
+	 (sym (make-string len :element-type 'base-char)))
     (read-n-bytes *fasl-input-stream* sym 0 len)
     (sb!vm:fixup-code-object code-object
 			     (read-word-arg)
diff -urN sbcl-0.8.16/src/code/host-c-call.lisp sbcl-0.8.16.patched/src/code/host-c-call.lisp
--- sbcl-0.8.16/src/code/host-c-call.lisp	2002-01-17 00:54:29.000000000 +0100
+++ sbcl-0.8.16.patched/src/code/host-c-call.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -14,9 +14,8 @@
 (define-alien-type-class (c-string :include pointer :include-args (to)))
 
 (define-alien-type-translator c-string ()
-  (make-alien-c-string-type :to
-			    (parse-alien-type 'char
-					      (sb!kernel::make-null-lexenv))))
+  (make-alien-c-string-type
+   :to (parse-alien-type 'char (sb!kernel:make-null-lexenv))))
 
 (define-alien-type-method (c-string :unparse) (type)
   (declare (ignore type))
@@ -24,7 +23,7 @@
 
 (define-alien-type-method (c-string :lisp-rep) (type)
   (declare (ignore type))
-  '(or simple-base-string null (alien (* char))))
+  '(or simple-string null (alien (* char))))
 
 (define-alien-type-method (c-string :naturalize-gen) (type alien)
   (declare (ignore type))
@@ -37,6 +36,37 @@
   `(etypecase ,value
      (null (int-sap 0))
      ((alien (* char)) (alien-sap ,value))
-     (simple-base-string (vector-sap ,value))))
+     (simple-base-string (vector-sap ,value))
+     (simple-string (vector-sap (coerce ,value 'simple-base-string)))))
+
+(/show0 "host-c-call.lisp 42")
+
+(define-alien-type-class (utf8-string :include pointer :include-args (to)))
+
+(define-alien-type-translator utf8-string ()
+  (make-alien-utf8-string-type
+   :to (parse-alien-type 'char (sb!kernel:make-null-lexenv))))
+
+(define-alien-type-method (utf8-string :unparse) (type)
+  (declare (ignore type))
+  'utf8-string)
+
+(define-alien-type-method (utf8-string :lisp-rep) (type)
+  (declare (ignore type))
+  '(or simple-string null (alien (* char))))
+
+(define-alien-type-method (utf8-string :naturalize-gen) (type alien)
+  (declare (ignore type))
+  `(if (zerop (sap-int ,alien))
+       nil
+       (%naturalize-utf8-string ,alien)))
+
+(define-alien-type-method (utf8-string :deport-gen) (type value)
+  (declare (ignore type))
+  `(etypecase ,value
+     (null (int-sap 0))
+     ((alien (* char)) (alien-sap ,value))
+     (simple-base-string (vector-sap ,value))
+     (simple-string (vector-sap (%deport-utf8-string ,value)))))
 
 (/show0 "host-c-call.lisp end of file")
diff -urN sbcl-0.8.16/src/code/interr.lisp sbcl-0.8.16.patched/src/code/interr.lisp
--- sbcl-0.8.16/src/code/interr.lisp	2003-08-02 17:58:07.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/interr.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -123,6 +123,16 @@
 	 :datum object
 	 :expected-type 'base-string))
 
+(deferr object-not-vector-nil-error (object)
+  (error 'type-error
+	 :datum object
+	 :expected-type '(vector nil)))
+
+(deferr object-not-character-string-error (object)
+  (error 'type-error
+	 :datum object
+	 :expected-type '(vector character)))
+
 (deferr object-not-bit-vector-error (object)
   (error 'type-error
 	 :datum object
@@ -190,10 +200,10 @@
 (deferr unbound-symbol-error (symbol)
   (error 'unbound-variable :name symbol))
 
-(deferr object-not-base-char-error (object)
+(deferr object-not-character-error (object)
   (error 'type-error
 	 :datum object
-	 :expected-type 'base-char))
+	 :expected-type 'character))
 
 (deferr object-not-sap-error (object)
   (error 'type-error
diff -urN sbcl-0.8.16/src/code/late-format.lisp sbcl-0.8.16.patched/src/code/late-format.lisp
--- sbcl-0.8.16/src/code/late-format.lisp	2004-09-15 21:48:33.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/late-format.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -39,7 +39,7 @@
   (string (missing-arg) :type simple-string)
   (start (missing-arg) :type (and unsigned-byte fixnum))
   (end (missing-arg) :type (and unsigned-byte fixnum))
-  (character (missing-arg) :type base-char)
+  (character (missing-arg) :type character)
   (colonp nil :type (member t nil))
   (atsignp nil :type (member t nil))
   (params nil :type list))
@@ -270,8 +270,11 @@
   (etypecase directive
     (format-directive
      (let ((expander
-	    (aref *format-directive-expanders*
-		  (char-code (format-directive-character directive))))
+            (let ((char (format-directive-character directive)))
+              (typecase char
+                (base-char
+                 (aref *format-directive-expanders* (char-code char)))
+                (character nil))))
 	   (*default-format-error-offset*
 	    (1- (format-directive-end directive))))
        (declare (type (or null function) expander))
@@ -685,7 +688,7 @@
 		 (setf args (nthcdr ,posn orig-args))
 		 (error 'format-error
 			:complaint "Index ~W out of bounds. Should have been ~
-				    between 0 and ~W."
+                                    between 0 and ~W."
 			:args (list ,posn (length orig-args))
 			:offset ,(1- end)))))
       (if colonp
@@ -702,7 +705,7 @@
 			(error 'format-error
 			       :complaint
 			       "Index ~W is out of bounds; should have been ~
-				between 0 and ~W."
+                                between 0 and ~W."
 			       :args (list new-posn (length orig-args))
 			       :offset ,(1- end)))))))
 	  (if params
@@ -1059,8 +1062,8 @@
 		   (if directive
 		       (error 'format-error
 			      :complaint
-			      "cannot include format directives inside the ~
-			       ~:[suffix~;prefix~] segment of ~~<...~~:>"
+                              "cannot include format directives inside the ~
+                               ~:[suffix~;prefix~] segment of ~~<...~~:>"
 			      :args (list prefix-p)
 			      :offset (1- (format-directive-end directive))
                               :references
diff -urN sbcl-0.8.16/src/code/late-type.lisp sbcl-0.8.16.patched/src/code/late-type.lisp
--- sbcl-0.8.16/src/code/late-type.lisp	2004-05-04 01:01:28.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/late-type.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -2096,22 +2096,22 @@
 	       (if (eq (car dims) '*)
 		   (case eltype
 		     (bit 'bit-vector)
-		     (base-char 'base-string)
+		     ((base-char) 'base-string)
 		     (* 'vector)
 		     (t `(vector ,eltype)))
 		   (case eltype
 		     (bit `(bit-vector ,(car dims)))
-		     (base-char `(base-string ,(car dims)))
+		     ((base-char) `(base-string ,(car dims)))
 		     (t `(vector ,eltype ,(car dims)))))
 	       (if (eq (car dims) '*)
 		   (case eltype
 		     (bit 'simple-bit-vector)
-		     (base-char 'simple-base-string)
+		     ((base-char) 'simple-base-string)
 		     ((t) 'simple-vector)
 		     (t `(simple-array ,eltype (*))))
 		   (case eltype
 		     (bit `(simple-bit-vector ,(car dims)))
-		     (base-char `(simple-base-string ,(car dims)))
+		     ((base-char) `(simple-base-string ,(car dims)))
 		     ((t) `(simple-vector ,(car dims)))
 		     (t `(simple-array ,eltype ,dims))))))
 	  (t
@@ -2378,18 +2378,24 @@
 
 (!def-type-translator member (&rest members)
   (if members
-      (let (ms numbers)
+      (let (ms numbers char-codes)
 	(dolist (m (remove-duplicates members))
 	  (typecase m
 	    (float (if (zerop m)
 		       (push m ms)
 		       (push (ctype-of m) numbers)))
 	    (real (push (ctype-of m) numbers))
+	    (character (push (sb!xc:char-code m) char-codes))
 	    (t (push m ms))))
 	(apply #'type-union
 	       (if ms
 		   (make-member-type :members ms)
 		   *empty-type*)
+	       (if char-codes
+		   (make-character-set-type
+		    :pairs (mapcar (lambda (x) (cons x x))
+				   (sort char-codes #'<)))
+		   *empty-type*)
 	       (nreverse numbers)))
       *empty-type*))
 
@@ -2562,6 +2568,7 @@
     ((type= type (specifier-type 'simple-string)) 'simple-string)
     ((type= type (specifier-type 'string)) 'string)
     ((type= type (specifier-type 'complex)) 'complex)
+    ((type= type (specifier-type 'standard-char)) 'standard-char)
     (t `(or ,@(mapcar #'type-specifier (union-type-types type))))))
 
 ;;; Two union types are equal if they are each subtypes of each
@@ -2834,6 +2841,89 @@
 		 (type-intersection (cons-type-car-type type1)
 				    (cons-type-car-type type2))
 		 cdr-int2)))))
+
+;;;; CHARACTER-SET types
+
+(!define-type-class character-set)
+
+(!def-type-translator character-set
+    (&optional (pairs '((0 . #.(1- sb!xc:char-code-limit)))))
+  (make-character-set-type :pairs pairs))
+
+(!define-type-method (character-set :negate) (type)
+  (let ((pairs (character-set-type-pairs type)))
+    (if (and (= (length pairs) 1)
+	     (= (caar pairs) 0)
+	     (= (cdar pairs) (1- sb!xc:char-code-limit)))
+	(make-negation-type :type type)
+	(let ((not-character
+	       (make-negation-type
+		:type (make-character-set-type
+		       :pairs '((0 . #.(1- sb!xc:char-code-limit)))))))
+	  (type-union
+	   not-character
+	   (make-character-set-type
+	    :pairs (let (not-pairs)
+		     (when (> (caar pairs) 0)
+		       (push (cons 0 (1- (caar pairs))) not-pairs))
+		     (do* ((tail pairs (cdr tail))
+			   (high1 (cdar tail))
+			   (low2 (caadr tail)))
+			  ((null (cdr tail))
+			   (when (< (cdar tail) (1- sb!xc:char-code-limit))
+			     (push (cons (1+ (cdar tail))
+					 (1- sb!xc:char-code-limit))
+				   not-pairs))
+			   (nreverse not-pairs))
+		       (push (cons (1+ high1) (1- low2)) not-pairs)))))))))
+
+(!define-type-method (character-set :unparse) (type)
+  (cond
+    ((type= type (specifier-type 'character)) 'character)
+    ((type= type (specifier-type 'base-char)) 'base-char)
+    ((type= type (specifier-type 'extended-char)) 'extended-char)
+    ((type= type (specifier-type 'standard-char)) 'standard-char)
+    (t (let ((pairs (character-set-type-pairs type)))
+	 `(member ,@(loop for (low . high) in pairs
+			  append (loop for code from low upto high
+				       collect (sb!xc:code-char code))))))))
+
+(!define-type-method (character-set :simple-=) (type1 type2)
+  (let ((pairs1 (character-set-type-pairs type1))
+	(pairs2 (character-set-type-pairs type2)))
+    (values (equal pairs1 pairs2) t)))
+ 
+(!define-type-method (character-set :simple-subtypep) (type1 type2)
+  (values
+   (dolist (pair (character-set-type-pairs type1) t)
+     (unless (position pair (character-set-type-pairs type2)
+		       :test (lambda (x y) (and (>= (car x) (car y))
+						(<= (cdr x) (cdr y)))))
+       (return nil)))
+   t))
+
+(!define-type-method (character-set :simple-union2) (type1 type2)
+  ;; KLUDGE: the canonizing in the MAKE-CHARACTER-SET-TYPE function
+  ;; actually does the union for us.  It might be a little fragile to
+  ;; rely on it.
+  (make-character-set-type
+   :pairs (merge 'list
+		 (copy-alist (character-set-type-pairs type1))
+		 (copy-alist (character-set-type-pairs type2))
+		 #'< :key #'car)))
+
+(!define-type-method (character-set :simple-intersection2) (type1 type2)
+  ;; KLUDGE: brute force.
+  (let (pairs)
+    (dolist (pair1 (character-set-type-pairs type1)
+	     (make-character-set-type
+	      :pairs (sort pairs #'< :key #'car)))
+      (dolist (pair2 (character-set-type-pairs type2))
+	(cond
+	  ((<= (car pair1) (car pair2) (cdr pair1))
+	   (push (cons (car pair2) (min (cdr pair1) (cdr pair2))) pairs))
+	  ((<= (car pair2) (car pair1) (cdr pair2))
+	   (push (cons (car pair1) (min (cdr pair1) (cdr pair2))) pairs)))))))
 				 
 ;;; Return the type that describes all objects that are in X but not
 ;;; in Y. If we can't determine this type, then return NIL.
diff -urN sbcl-0.8.16/src/code/package.lisp sbcl-0.8.16.patched/src/code/package.lisp
--- sbcl-0.8.16/src/code/package.lisp	2004-06-29 10:50:59.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/package.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -73,7 +73,7 @@
   #!+sb-doc
   "the standard structure for the description of a package"
   ;; the name of the package, or NIL for a deleted package
-  (%name nil :type (or simple-base-string null))
+  (%name nil :type (or simple-string null))
   ;; nickname strings
   (%nicknames () :type list)
   ;; packages used by this package
@@ -99,7 +99,7 @@
   ;; shadowing symbols
   (%shadowing-symbols () :type list)
   ;; documentation string for this package
-  (doc-string nil :type (or simple-base-string null))
+  (doc-string nil :type (or simple-string null))
   ;; package locking
   #!+sb-package-locks
   (lock nil :type boolean)
@@ -290,7 +290,7 @@
 	      (error 'simple-program-error
 		     :format-control
 		     "At least one of :INTERNAL, :EXTERNAL, or ~
-		      :INHERITED must be supplied."))
+                      :INHERITED must be supplied."))
 	   ,(dolist (symbol symbol-types)
 	      (unless (member symbol '(:internal :external :inherited))
 		(error 'program-error
diff -urN sbcl-0.8.16/src/code/pprint.lisp sbcl-0.8.16.patched/src/code/pprint.lisp
--- sbcl-0.8.16/src/code/pprint.lisp	2004-10-20 10:15:29.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/pprint.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -119,7 +119,7 @@
 
 (defun pretty-out (stream char)
   (declare (type pretty-stream stream)
-	   (type base-char char))
+	   (type character char))
   (cond ((char= char #\newline)
 	 (enqueue-newline stream :literal))
 	(t
@@ -662,15 +662,15 @@
    *STANDARD-OUTPUT*) if it is a pretty-printing stream, and do
    nothing if not. KIND can be one of:
      :LINEAR - A line break is inserted if and only if the immediatly
-	containing section cannot be printed on one line.
+        containing section cannot be printed on one line.
      :MISER - Same as LINEAR, but only if ``miser-style'' is in effect.
-	(See *PRINT-MISER-WIDTH*.)
+        (See *PRINT-MISER-WIDTH*.)
      :FILL - A line break is inserted if and only if either:
        (a) the following section cannot be printed on the end of the
-	   current line,
+           current line,
        (b) the preceding section was not printed on a single line, or
        (c) the immediately containing section cannot be printed on one
-	   line and miser-style is in effect.
+           line and miser-style is in effect.
      :MANDATORY - A line break is always inserted.
    When a line break is inserted by any type of conditional newline, any
    blanks that immediately precede the conditional newline are ommitted
@@ -694,7 +694,7 @@
    and do nothing if not. (See PPRINT-LOGICAL-BLOCK.)  N is the indentation
    to use (in ems, the width of an ``m'') and RELATIVE-TO can be either:
      :BLOCK - Indent relative to the column the current logical block
-	started on.
+        started on.
      :CURRENT - Indent relative to the current column.
    The new indentation value does not take effect until the following line
    break."
diff -urN sbcl-0.8.16/src/code/pred.lisp sbcl-0.8.16.patched/src/code/pred.lisp
--- sbcl-0.8.16/src/code/pred.lisp	2003-07-16 10:26:01.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/pred.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -64,6 +64,7 @@
   ;; the type it tests for in the Common Lisp type system, and since it's
   ;; only used in the implementation of a few specialized things.)
   (def-type-predicate-wrapper double-float-p)
+  (def-type-predicate-wrapper extended-char-p)
   (def-type-predicate-wrapper fdefn-p)
   (def-type-predicate-wrapper fixnump)
   (def-type-predicate-wrapper floatp)
@@ -78,7 +79,7 @@
   (def-type-predicate-wrapper ratiop)
   (def-type-predicate-wrapper realp)
   (def-type-predicate-wrapper short-float-p)
-  (def-type-predicate-wrapper sb!kernel:simple-array-p)
+  (def-type-predicate-wrapper simple-array-p)
   (def-type-predicate-wrapper simple-bit-vector-p)
   (def-type-predicate-wrapper simple-base-string-p)
   (def-type-predicate-wrapper simple-string-p)
@@ -127,6 +128,8 @@
 	 '(integer #.(1+ sb!xc:most-positive-fixnum))
 	 'bignum))
     (standard-char 'standard-char)
+    (base-char 'base-char)
+    (extended-char 'extended-char)
     ((member t) 'boolean)
     (keyword 'keyword)
     ((or array complex) (type-specifier (ctype-of object)))
diff -urN sbcl-0.8.16/src/code/primordial-extensions.lisp sbcl-0.8.16.patched/src/code/primordial-extensions.lisp
--- sbcl-0.8.16/src/code/primordial-extensions.lisp	2004-09-09 14:10:14.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/primordial-extensions.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -167,30 +167,15 @@
 ;;; producing a symbol in the current package.
 (eval-when (#-sb-xc :compile-toplevel :load-toplevel :execute)
   (defun symbolicate (&rest things)
-    (let ((name (case (length things)
-		  ;; Why isn't this just the value in the T branch?
-		  ;; Well, this is called early in cold-init, before
-		  ;; the type system is set up; however, now that we
-		  ;; check for bad lengths, the type system is needed
-		  ;; for calls to CONCATENATE. So we need to make sure
-		  ;; that the calls are transformed away:
-		  (1 (concatenate 'string
-				  (the simple-base-string
-				    (string (car things)))))
-		  (2 (concatenate 'string 
-				  (the simple-base-string
-				    (string (car things)))
-				  (the simple-base-string
-				    (string (cadr things)))))
-		  (3 (concatenate 'string
-				  (the simple-base-string
-				    (string (car things)))
-				  (the simple-base-string
-				    (string (cadr things)))
-				  (the simple-base-string
-				    (string (caddr things)))))
-		  (t (apply #'concatenate 'string (mapcar #'string things))))))
-    (values (intern name)))))
+    (let* ((length (reduce #'+ things
+                           :key (lambda (x) (length (string x)))))
+           (name (make-array length :element-type 'character)))
+      (let ((index 0))
+        (dolist (thing things (values (intern name)))
+          (let* ((x (string thing))
+                 (len (length x)))
+            (replace name x :start1 index)
+            (incf index len)))))))
 
 ;;; like SYMBOLICATE, but producing keywords
 (defun keywordicate (&rest things)
